--アリス・マーガトロイド用ai
--しなうす式/20220710check

require("function_pun_strage.lua")
head_req_list()

function main()
--シード生成、スレッド生成、base_states設定
	set_seedthreadstates()
--キャラ確認
	char_calling()
--ステージが 核融合炉心部 だと超反応モードに
	set_printsabot()

while true do
--スレッド外初期化
	while_top()

--●どちらかが体力無くなったら待機
	if interbattle_condi()==true then
		interbattle_exe()
--▼開幕行動▼
	elseif kaimaku_condi()==true then
		kaimaku_exe()
--▼移動起き上がり
	elseif my_act==97 or my_act==98 then --基本：画面端より遠ざかる。中央では相手から遠ざか…りたいが、設置技警戒のため、相手側に移動起き上がり。
		movedgetup_exe()

--▼簡易受け身▼：攻撃ないし回避いずれの目的であってもリカバリーポイントは限られるが、そういうことはさておき実装したもの
	elseif recovery_condi()==true then
		recovery_exe()

--▼台風になった時、フラグに従って「緋想の剣」を使用
	elseif y==0 and my_act<=10 and card_check(14) and flag_kishitu==1 then
		print("天候フラグＯＮ　⇒　「緋想の剣」使用");
		card_use(14);

--▼台風▼：近接状態からの強引な状況変更を行う行動。スペカなど使用。
	elseif react_rejecttaihu_condi()==true then
		react_rejecttaihu_exe()

--▼起き攻め▼
	elseif setplay_ongetup_condi()==true then
		setplay_ongetup_exe()
--▼ＨＪＣ▼
	--地上HJC
	elseif hjc_ground_condi()==true then
		hjc_ground_exe()
	--空中HJC
	elseif hjc_air_condi()==true then
		hjc_air_exe()

--▼反応行動
--反応：下段
	elseif 	react_lowattack_condi()==true then
		react_lowattack_exe()
--反応：地対空
	elseif react_g2a_condi()==true then
		react_g2a_exe()
--反応：低空飛翔
	elseif react_lowj6d_condi()==true then
		react_lowj6d_exe()
--上空追いかけ
	elseif ueoikake_condi()==true then
		ueoikake_exe()
--霊撃 or 霊撃札
	elseif reigeki_condi()==true then 
		print("拒否行動：霊撃　⇒　可能ならば使用");
		card_use(0)
		
--▼グレイズ：相手行動に対する反射or一定距離内のオブジェクト感知▼
--モーション反応グレイズ
	elseif
	graze_condition_xrange()==true and
	state_nottrueguard()==true and 
	my_airEX>=1 and 
	my_rei>=0 
	then--近距離時のグレイズ。のさばらせておくと、誤結界の原因となる。ガードの硬直間際ならok
		print("check 1 -> graze act X Range");
		graze_action_xrange()
			
--▼ ガード行動：簡易ガードルーチン▼
--▼ ガード反撃、龍魚の羽衣 13
	elseif hagoromo_1st_condi()==true or hagoromo_condi()==true then
		hagoromo_exe()

--回避結界
	elseif kekkai_condi()==true then
		kekkai_exe()

--▼ 宵越しの銭 12
	elseif yoikoshi_1st_condi()==true or yoikoshi_condi()==true then
		yoikoshi_exe()

--▼汎用中下段ガード
--基本は行動に対して後退入れ込み。下段のみ抽出して反応。通常射撃も同じく下段で受ける(けどメンドウだから今回は省き)。フラグを抜けてくるものは別個に対応
	elseif lowattack_aflags_condi()==true then
		guard_backexpectlowattack_exe()
	elseif overheadattack_aflags_condi()==true then
		guard_backoverheadattack_exe()
--下段判定をフィルタ
	elseif lowattack_flaged_condi()==true then
		guard_backexpectlowattack_exe()
--フラグを抜けてくるものをフィルタ
	elseif lowattack_unflaged_condi()==true then
		guard_backexpectlowattack_exe()
--屈状態では低空昇り攻撃には立てない
	elseif notstand_overhead_upjump_condi()==true then
		guard_backexpectlowattack_exe()
--以下、何もフィルタされなかった場合、立ちガード
	elseif guard_pun_condi()==true then
		guard_backoverheadattack_exe()

--[[▼オブジェが至近距離の場合、着地直前にｈｊを仕込む、タッチ＆ゴーグレイズ
	elseif touchandgo_00_condi() then
		touchandgo_00_exe()
--オブジェが至近距離の場合、ガードの前に、離陸
	elseif touchandgo_01_condi() then
		touchandgo_01_exe()
	elseif touchandgo_02_condi() then
		touchandgo_02_exe()
--]]
--オブジェが至近距離の場合、空中から地上へ飛翔　※咲夜：２D：120.0以上、３D：84.9以上必要
	elseif graze_pun_condi()==true then
		graze_pun_exe()
		
--遠距離時のグレイズ
	elseif graze_farground_condi() then
		graze_farground_exe()
	elseif graze_farair_condi() then
		graze_farair_exe()
		
--特定状況におけるガード
	elseif guard_objgimmick_condi()==true then
		guard_backexpectlowattack_exe()
--オブジェが至近距離の場合、ガード:射撃と打撃を重ねられると、しゃがみガードしてしまう。優先順位の変更が必要
	elseif guard_objclosedis_condi()==true then
		guard_backexpectlowattack_exe()
	
--▼起き上がり直後の行動
	elseif move_soonaftergetup_condi()==true then
		move_soonaftergetup_exe()

--▼コンボ▼
--簡易スペカコンボ
--咒詛「蓬莱人形」
	elseif card_check(205)==true and my_spell_more(2000) and 
	(
	my_act==302 or 
	(my_act==305 and get_correction(0,32)) or 
	my_act==322 
	) and ((enemy_act>=50 and enemy_act<=89)or(enemy_act>=143 and enemy_act<=145)) then
		if my_allframe>=10 and my_allframe<=30 then
			print("簡易コンボ：スペルカード　咒詛「蓬莱人形」");
			card_use(205);
		end
		card_1st(205);
--咒符「上海人形」
	elseif card_check(202)==true and my_spell_more(2000) and 
	(
	my_act==302 or 
	(my_act==305 and get_correction(0,32)) or 
	my_act==322 
	) and ((enemy_act>=50 and enemy_act<=89)or(enemy_act>=143 and enemy_act<=145)) then
		if my_allframe>=10 and my_allframe<=30 then
			print("簡易コンボ：スペルカード　咒符「上海人形」");
			card_use(202);
		end
		card_1st(202);
--AAAA連携
--AAAA>DA>2A>3A>B>JA>J6A
--AA
	elseif my_act==300 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_hitstop<=3 and my_hitstop>=2 and is_dir_front==true then
		print("コンボ：A>ＡＡ");
		key_event(ACT_A);
	--AAA
		elseif ey==0 and my_act==320 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_hitstop<=3 and my_hitstop>=2 and is_dir_front==true then
			print("コンボ：AA>ＡＡＡ");
			key_event(ACT_A);
		--AAAA
			elseif ey==0 and my_act==321 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_hitstop<=3 and my_hitstop>=2 and is_dir_front==true then
				print("コンボ：AAA>ＡＡＡＡ");
				key_event(ACT_A);
				
--AAAA>2A>3A(3Hit)>6B(0)>9hj>JA>J8A
			--AAAA>2A
				elseif my_act==322 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_allframe>=48-2 and is_dir_front==true and ((my_dir==1 and x>=960)or(my_dir==-1 and x<=320)) then
					print("コンボ：AAAA>2A",ey);
					key_resetEX();
					key_on(front);
					while (ey>=50) do
						yield();
					end
					key_resetEX();
					key_event2(ACT_A,ACT_DOWN);
					wait(11)
				--2A>3A(3Hit)
					if my_act==303 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and is_dir_front==true then
						wait(my_hitstop-2);
						print("AAAA＞2Ａ＞3Ａ");
						key_resetEX();
						key_event2(ACT_A,d_front);
						wait(23)
					--3A>B
						if my_act==304 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and is_dir_front==true and my_rei>=200 then
							print("AAAA＞2Ａ＞3Ａ＞B");
							key_resetEX();
							key_event2(ACT_B,front);
							wait(17-2);
							key_event(u_front);
							wait(2);
							print("AAAA＞2Ａ＞3Ａ＞B＞JA");
							key_event(ACT_A);
							wait(11);
							wait(my_hitstop-2);
							print("AAAA＞2Ａ＞3Ａ＞B＞JA＞J8A");
							key_event2(ACT_A,ACT_UP);
						end
					end
						
			--AAAA>DA 壁より340<x<640
				elseif my_act==322 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_allframe>=48-2 and is_dir_front==true and ((my_dir==1 and x>=620 and x<=960)or(my_dir==-1 and x>=320 and x<=660)) then
					print("コンボ：AAAA>DA");
					key_resetEX();
					key_on(front);
					wait(5);
					key_on(ACT_D);
					key_event2(ACT_A,front);
				--DA>2A
					elseif my_act==305 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_allframe>=34-2 and is_dir_front==true and ((my_dir==1 and x>=840)or(my_dir==-1 and x<=440)) then
						print("コンボ：DA>2A",ey);
						key_resetEX();
						key_on(front);
						while (ey>=70) do
							yield();
						end
						key_resetEX();
						key_event2(ACT_A,ACT_DOWN);
					--2A>3A
						elseif my_act==303 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_hitstop<=3 and my_hitstop>=2 and is_dir_front==true then
							print("2Ａ＞３Ａ");
							key_resetEX();
							key_event2(ACT_A,d_front);
						--3A>B
							elseif my_act==304 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_allframe>=15 and is_dir_front==true and my_rei>=200 then
								print("3Ａ＞B");
								key_resetEX();
								key_event(ACT_B);
								wait(21+3+3);
								key_event(u_back);
								wait(2);
								key_event2(ACT_A,front);
								
			--AAAA＞6A
				elseif my_act==322 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_allframe>=48-2 and is_dir_front==true then
					key_resetEX();
					print("AAAA＞6Ａ");
					key_event2(ACT_A,front);
								
--遠A>6A
	elseif my_act==301 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_combo>=3 and is_dir_front==true then
		key_resetEX();
		print("遠Ａ＞6Ａ");
		key_event2(ACT_A,front);
	--6A>6B
		elseif my_act==302 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_allframe>=15-2 and enemy_frame<=1 and is_dir_front==true then
			key_resetEX();
			print("6Ａ＞6B");
			key_event2(ACT_B,front);
			while (my_act==401 and (my_limit<100 or my_allframe<=42)) do
				yield();
			end
		
--JA>J6A
	elseif my_act==306 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_hitstop<=3 and my_hitstop>=2 and is_dir_front==true then
		key_resetEX();
		print("ＪＡ＞Ｊ６Ａ"); 
		key_event2(ACT_A,front);
	--J6A>J6B
		elseif my_act==307 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_allframe>=15-2 and enemy_frame<=1 and is_dir_front==true then
			key_resetEX();
			print("J6Ａ＞J6B");
			key_event2(ACT_B,front);
			while (my_act==405 and (my_limit<100 or my_allframe<=51)) do
				yield();
			end
			
				  
--▼固め▼
								
--▼コンボ・固め兼用▼

--▼攻撃▼

--▼spell card▼

--▼cost1

--魔符「アーティフルサクリファイス」,200,600,g
	--Ground
	elseif card_check(200)==true and
	my_spell_more(500) and
	--dis2<200 and
	y==0 and
	ey<50 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("魔符「アーティフルサクリファイス」");
		for i=1,10 do
			card_use(200);
			yield()
		end

--▼cost2

--戦符「リトルレギオン」,201,601,g
	--Ground
	elseif card_check(201)==true and
	my_spell_more(1000) and
	dis2<500 and
	y==0 and
	--ey<50 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("戦符「リトルレギオン」");
		for i=1,10 do
			card_use(201);
			yield()
		end

--咒符「上海人形」,202,602,g
	--Ground
	elseif card_check(202)==true and
	my_spell_more(1000) and
	--dis<320 and
	y==0 and
	ey<50 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("咒符「上海人形」");
		for i=1,10 do
			card_use(202);
			yield()
		end

--偵符「シーカードールズ」,206,606,g
	--Ground
	elseif card_check(206)==true and
	my_spell_more(1000) and
	--dis<320 and
	y==0 and
	--ey<50 and
	dis_y<100 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("偵符「シーカードールズ」");
		for i=1,10 do
			card_use(206);
			yield()
		end

--注力「トリップワイヤー」,209,609,659,g,a
	--Ground
	--air
	elseif card_check(209)==true and
	my_spell_more(1000) and
	--dis<320 and
	--y==0 and
	--ey<50 and
	dis_y<100 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	--enemy_obj_range_in(150,60)==false and 
	--is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("注力「トリップワイヤー」");
		for i=1,10 do
			card_use(209);
			yield()
		end


--▼cost3

--魔操「リターンイナニメトネス」,203,603,g
	--Ground
	elseif card_check(203)==true and
	my_spell_more(1500) and
	--dis>150 and
	--dis<350 and
	y==0 and
	--ey<100 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("魔操「リターンイナニメトネス」");
		for i=1,10 do
			card_use(203);
			yield()
		end

--人形「未来文楽」,208,608,g
	--Ground
	elseif card_check(208)==true and
	my_spell_more(1500) and
	--dis<400 and
	y==0 and
	--dis_y<100 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	--is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("人形「未来文楽」");
		for i=1,10 do
			card_use(208);
			yield()
		end

--▼cost4

--戦操「ドールズウォー」,204,604,g
	--Ground
	elseif card_check(204)==true and
	my_spell_more(2000) and
	dis2<400 and
	y==0 and
	ey<200 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	--enemy_obj_range_in(150,60)==false and 
	--is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("戦操「ドールズウォー」");
		for i=1,10 do
			card_use(204);
			yield()
		end

--咒詛「蓬莱人形」,205,605,g
	--Ground
	elseif card_check(205)==true and
	my_spell_more(2000) and
	--dis<800 and
	y==0 and
	dis_y<50 and
	--ey<100 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("咒詛「蓬莱人形」");
		for i=1,10 do
			card_use(205);
			yield()
		end

--紅符「和蘭人形」,207,607,657,g,a
	--Ground
	--air
	elseif card_check(207)==true and
	my_spell_more(2000) and
	--dis2<300 and
	--y==0 and
	--ey>180 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	--is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("紅符「和蘭人形」");
		for i=1,10 do
			card_use(207);
			yield()
		end

--槍符「キューティ大千槍」,210,610,g,a
	--Ground
	--air
	elseif card_check(210)==true and
	my_spell_more(2000) and
	dis<300 and
	--y==0 and
	dis_y<100 and
	--ey<100 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("槍符「キューティ大千槍」");
		for i=1,10 do
			card_use(210);
			yield()
		end

--▼cost5

--人形「レミングスパレード」,211,611,g
	--Ground
	elseif card_check(211)==true and
	my_spell_more(2500) and
	--dis<250 and
	y==0 and
	ey<100 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("人形「レミングスパレード」");
		for i=1,10 do
			card_use(211);
			yield()
		end

--[[
--▼skill card▼

	--▼スキル236

		--博麗アミュレット,100,500,g,a
			--g,a
				elseif get_skill_lv(0,0)>=0 and my_rei>=400 and 
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("博麗アミュレット");
						lvr236(ACT_B);
				
				elseif get_skill_lv(0,0)>=0 and my_rei>=400 and 
					dis>450 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("博麗アミュレット");
						lvr236(ACT_C);
					
				elseif card_check(100)==true and my_rei>=400 and
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("博麗アミュレット");
						card_use(100);
		
		--妖怪バスター,104,505,g,a
			--g,a
				elseif get_skill_lv(0,4)>=0 and my_rei>=400 and 
					dis>200 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("妖怪バスター");
						lvr236(ACT_B);
					
				elseif get_skill_lv(0,4)>=0 and my_rei>=400 and 
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("妖怪バスター");
						lvr236(ACT_C);
					
				elseif card_check(104)==true and my_rei>=400 and
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("妖怪バスター");
						card_use(104);
		
		--拡散アミュレット,108,510,g

				elseif get_skill_lv(0,8)>=0 and my_rei>=400 and 
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("拡散アミュレット");
						lvr236(ACT_B);
					
				elseif get_skill_lv(0,8)>=0 and my_rei>=400 and 
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("拡散アミュレット");
						lvr236(ACT_C);
					
				elseif card_check(108)==true and my_rei>=400 and
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("拡散アミュレット");
						card_use(108);
		
	--▼スキル623

		--昇天脚,103,560,g

				elseif get_skill_lv(0,3)>=0 and my_rei>=400 and 
					dis<150 and
					y==0 and
					ey<200 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("昇天脚");
						lvr623(ACT_B);
					
				elseif get_skill_lv(0,3)>=0 and my_rei>=400 and 
					dis<150 and
					y==0 and
					ey<300 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					--enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("昇天脚");
						lvr623(ACT_C);
					
				elseif card_check(103)==true and my_rei>=400 and
					dis<150 and
					y==0 and
					ey<200 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("昇天脚");
						card_use(103);
		
		--抄地昇天脚,107,565,g
			--g
				elseif get_skill_lv(0,7)>=0 and my_rei>=400 and 
					dis<200 and
					y==0 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("抄地昇天脚");
						lvr623(ACT_B);
					
				elseif get_skill_lv(0,7)>=0 and my_rei>=400 and 
					dis<300 and
					y==0 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("抄地昇天脚");
						lvr623(ACT_C);
					
				elseif card_check(107)==true and my_rei>=400 and
					dis<200 and
					y==0 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("抄地昇天脚");
						card_use(107);
		
		--雨乞祈り,111,570,g,a
			--g,a
				elseif get_skill_lv(0,11)>=0 and my_rei>=400 and 
					dis<200 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("雨乞祈り");
						lvr623(ACT_B);
					
				elseif get_skill_lv(0,11)>=0 and my_rei>=400 and 
					dis<200 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("雨乞祈り");
						lvr623(ACT_C);
					
				elseif card_check(111)==true and my_rei>=400 and
					dis<200 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("雨乞祈り");
						card_use(111);

	--▼スキル421
		--亜空穴,102,540,g,a
			--g,a
				elseif get_skill_lv(0,2)>=0 and my_rei>=400 and 
					not(my_act>=50 and my_act<180) and my_act<600 and
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("亜空穴");
						lvr421(ACT_B);
					
				elseif get_skill_lv(0,2)>=0 and my_rei>=400 and 
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("亜空穴");
						lvr421(ACT_C);
					
				elseif card_check(102)==true and my_rei>=400 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("亜空穴");
						card_use(102);
		
		--封魔亜空穴,106,545,g,a
			--g,a
				elseif get_skill_lv(0,6)>=0 and my_rei>=400 and 
					dis<300 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("封魔亜空穴");
						lvr421(ACT_B);
					
				elseif get_skill_lv(0,6)>=0 and my_rei>=400 and 
					dis>300 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("封魔亜空穴");
						lvr421(ACT_C);
					
				elseif card_check(106)==true and my_rei>=400 and
					dis<300 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("封魔亜空穴");
						card_use(106);
		
		--刹那亜空穴,110,550,g
			--g
				elseif get_skill_lv(0,10)>=0 and my_rei>=400 and 
					dis2<300 and
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					enemy_act>300 and
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("刹那亜空穴");
						lvr421(ACT_B);
					
				elseif get_skill_lv(0,10)>=0 and my_rei>=400 and 
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==true and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("刹那亜空穴");
						lvr421(ACT_C);
					
				elseif card_check(110)==true and my_rei>=400 and
					dis2<300 and
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					enemy_act>300 and
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("刹那亜空穴");
						card_use(110);

	--▼スキル214
		--警醒陣,101,520,g,a
			--g,a
				elseif get_skill_lv(0,1)>=0 and my_rei>=400 and 
					dis>200 and dis<500 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("警醒陣");
						lvr214(ACT_B);
					
				elseif get_skill_lv(0,1)>=0 and my_rei>=400 and 
					dis>300 and dis<600 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("警醒陣");
						lvr214(ACT_C);
					
				elseif card_check(101)==true and my_rei>=400 and
					dis>200 and dis<500 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("警醒陣");
						card_use(101);	
		
		--繋縛陣,105,525,g,a
			--g,a
				elseif get_skill_lv(0,5)>=0 and my_rei>=400 and 
					dis2>300 and
					math.abs(enemy_xspeedEX)>5 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("繋縛陣");
						lvr214(ACT_B);
					
				elseif get_skill_lv(0,5)>=0 and my_rei>=400 and 
					dis2>300 and
					math.abs(enemy_yspeed)>5 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("繋縛陣");
						lvr214(ACT_C);
					
				elseif card_check(105)==true and my_rei>=400 and
					dis2>300 and
					math.abs(enemy_xspeedEX)>5 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("繋縛陣");
						card_use(105);
		
		--常置陣,109,530,g
			--g
				elseif get_skill_lv(0,9)>=0 and my_rei>=400 and 
					dis2>300 and
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("常置陣");
						lvr214(ACT_B);
					
				elseif get_skill_lv(0,9)>=0 and my_rei>=400 and 
					dis2>500 and
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("常置陣");
						lvr214(ACT_C);
					
				elseif card_check(109)==true and my_rei>=400 and
					dis2>300 and
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("常置陣");
						card_use(109);
--]]
			
--▼攻撃▼
--空中行動
--ＪＡ
	elseif	y>0 and math.random(1+4)<=3 and 
	(my_act<=10 or (my_act>=180 and my_act<300)) and 
	not(my_act>=197 and my_act<=199) and
	not(enemy_act>=98 and enemy_act<=98) and
	not(enemy_act>=197 and enemy_act<=199) and
	enemy_obj_range_in(150,60)==false and
	is_dir_front and subs_count>=530 and nega_count ~= 1 and math.random(2)==1 and
	(y+my_yspeed*13+(13*(12*m_gs))/2)>0 	and
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*13		<=	140+30 	and
				--(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*13		>=	30-30 	and
				(ey+enemy_yspeed*13+(13*(12*e_gs))/2)	-	(y+my_yspeed*13+(13*(12*m_gs))/2)	<=	100		and
				(ey+enemy_yspeed*13+(13*(12*e_gs))/2)	-	(y+my_yspeed*13+(13*(12*m_gs))/2)	>=	40-180 	then
					print("JA");
					key_resetEX();
					key_event(ACT_A);
--Ｊ６Ａ
	elseif	y>0 and math.random(1+4)<=3 and 
	(my_act<=10 or (my_act>=180 and my_act<300)) and 
	not(my_act>=197 and my_act<=199) and
	not(my_act>=208 and my_act<=210) and
	not(enemy_act>=98 and enemy_act<=98) and
	not(enemy_act>=197 and enemy_act<=199) and
	enemy_obj_range_in(150,60)==false and
	is_dir_front and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and
	(y+my_yspeed/5*17)>0 	and
				(ex-x)*my_dir-(my_xspeedEX/5*17+enemy_xspeedEX*17)		<=	400+30 	and
				(ex-x)*my_dir-(my_xspeedEX/5*17+enemy_xspeedEX*17)		>=	200-30 	and
				(ey+enemy_yspeed*17+(17*(16*e_gs))/2)	-	(y+my_yspeed/5*17)	<=	140 		and
				(ey+enemy_yspeed*17+(17*(16*e_gs))/2)	-	(y+my_yspeed/5*17)	>=	80-180 	then
					print("J6A");
					key_resetEX();
					key_event2(ACT_A,front);--]]
--[[Ｊ２Ａ
	elseif	y>0 and math.random(1+4)<=3 and 
	(my_act<=10 or (my_act>=180 and my_act<300)) and 
	not(enemy_act>=98 and enemy_act<=98) and
	not(enemy_act>=197 and enemy_act<=199) and
	enemy_obj_range_in(150,60)==false and
	is_dir_front and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and
	(y+my_yspeed/5*17)>0 	and
				(ex-x)*my_dir-(my_xspeedEX/2*17+enemy_xspeed*17)		<=	100+30 	and
				(ex-x)*my_dir-(my_xspeedEX/2*17+enemy_xspeed*17)		>=	10-30 	and
				(ey+enemy_yspeed*5+(5*(4*e_gs))/2)	-	(y+my_yspeed/5*17)	<=	120 			and
				(ey+enemy_yspeed*5+(5*(4*e_gs))/2)	-	(y+my_yspeed/5*17)	>=	40-180 	then
					print("J2A");
					key_resetEX();
					key_event2(ACT_A,ACT_DOWN);--
--Ｊ８Ａ
	elseif	y>0 and math.random(1+4)<=3 and
	(my_act<=10 or (my_act>=180 and my_act<300)) and 
	not(enemy_act>=98 and enemy_act<=98) and
	not(enemy_act>=197 and enemy_act<=199) and
	enemy_obj_range_in(150,60)==false and
	is_dir_front and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and
	(y+my_yspeed/5*15)>0 	and
				(ex-x)*my_dir-(0+enemy_xspeedEX)*5		<=	80+30 	and
				(ex-x)*my_dir-(0+enemy_xspeedEX)*5		>=	0-30 	and
				(ey+enemy_yspeed*5+(5*(4*e_gs))/2)	-	(y+my_yspeed/5*15)	<=	280 		and
				(ey+enemy_yspeed*5+(5*(4*e_gs))/2)	-	(y+my_yspeed/5*15)	>=	180-180 	then
					print("J8A");
					key_resetEX();
					key_event2(ACT_A,ACT_UP);--]]

--対空Ａ
	elseif y==0 and ey>0 and enemy_obj_range_in(150,60)==false and my_act<=10 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and is_dir_front==true and
	((not(enemy_act>=50 and enemy_act<=166)and math.random(1+5)==1) or (enemy_act>=50 and enemy_act<=166)) and 
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and
		(	
			(	dis>=150 and
				(ex)*my_dir-(enemy_xspeedEX)*13		<=	400+30 	and
				(ex)*my_dir-(enemy_xspeedEX)*13		>=	200-30 	and
				(ey+enemy_yspeed*13+(13*(12*e_gs))/2)	<=	140 		and
				(ey+enemy_yspeed*13+(13*(12*e_gs))/2)	>=	40-180
			) or
			(	dis<150 and
				(ex)*my_dir-(enemy_xspeedEX)*11		<=	120+30 	and
				--(ex)*my_dir-(enemy_xspeedEX)*11		>=	20-30 	and
				(ey+enemy_yspeed*11+(11*(10*e_gs))/2)	<=	60 		and
				(ey+enemy_yspeed*11+(11*(10*e_gs))/2)	>=	20-180
			)
		) then
		print("対空Ａ");
		key_event(ACT_A);
--対空3Ａ
	elseif y==0 and ey>0 and enemy_obj_range_in(150,60)==false and my_act<=10 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and is_dir_front==true and
	((not(enemy_act>=50 and enemy_act<=166)and math.random(1+5)==1) or (enemy_act>=50 and enemy_act<=166)) and 
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and
		(			
				(ex)*my_dir-(enemy_xspeedEX)*17		<=	300+30 	and
				(ex)*my_dir-(enemy_xspeedEX)*17		>=	150-30 	and
				(ey+enemy_yspeed*17+(17*(16*e_gs))/2)	<=	200 		and
				(ey+enemy_yspeed*17+(17*(16*e_gs))/2)	>=	20-180
		) then
		print("対空Ａ");
		key_event(ACT_A);
--対空9HJ>JＡ:14F それなりに機能する。対地上りJAも兼ねる。
	elseif y==0 and 
	(ey>0 or
		(
			(enemy_char~=19 and (enemy_act==0 or (enemy_act>=5 and enemy_act<=10) or (enemy_act>=150 and enemy_act<=153) or (enemy_act>=159 and enemy_act<=162))
			) or
			(enemy_char==19 and ((enemy_act>=1 and enemy_act<=3) or (enemy_act>=154 and enemy_act<=157) or (enemy_act>=163 and enemy_act<=166))
			)
		)
	) and 
	enemy_obj_range_in(150,60)==false and
	my_act<=10 and 
	not(enemy_act>=97 and enemy_act<=98) and 
	not(enemy_act>=197 and enemy_act<=199) and 
	is_dir_front==true and
	(
		(not(enemy_act>=50 and enemy_act<=166)) or (enemy_act>=50 and enemy_act<=166)
	) and 
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and 
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*15		<=	170+30 	and
				--(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*15		>=	80-30 	and
				(ey+enemy_yspeed*15+(15*(14*e_gs))/2)	-	(y+my_yspeed*15+(15*(14*m_gs))/2)	<=	150 		and
				(ey+enemy_yspeed*15+(15*(14*e_gs))/2)	-	(y+my_yspeed*15+(15*(14*m_gs))/2)	>=	110-120 	then
		print("対空9HJ>JＡ");
		key_event2(ACT_D,u_front)
		key_reset()
		wait(2)
		key_event(ACT_A);--]]
--対空8HJ>JＡ:14F
	elseif y==0 and 
	(ey>0 or
		(
			(enemy_char~=19 and (enemy_act==0 or (enemy_act>=5 and enemy_act<=10) or (enemy_act>=150 and enemy_act<=153) or (enemy_act>=159 and enemy_act<=162))
			) or
			(enemy_char==19 and ((enemy_act>=1 and enemy_act<=3) or (enemy_act>=154 and enemy_act<=157) or (enemy_act>=163 and enemy_act<=166))
			)
		)
	) and 
	enemy_obj_range_in(150,60)==false and
	my_act<=10 and 
	not(enemy_act>=97 and enemy_act<=98) and 
	not(enemy_act>=197 and enemy_act<=199) and 
	is_dir_front==true and
	(
		(not(enemy_act>=50 and enemy_act<=166)) or (enemy_act>=50 and enemy_act<=166)
	) and 
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and 
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*15		<=	50+30 	and
				--(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*15		>=	-40-30 	and
				(ey+enemy_yspeed*15+(15*(14*e_gs))/2)	-	(y+my_yspeed*15+(15*(14*m_gs))/2)	<=	181 		and
				(ey+enemy_yspeed*15+(15*(14*e_gs))/2)	-	(y+my_yspeed*15+(15*(14*m_gs))/2)	>=	121-120 	then
		print("対空8HJ>JＡ");
		key_event2(ACT_D,ACT_UP)
		key_reset()
		wait(2)
		key_event(ACT_A);--]]
--ダッシュ＞4Ａ
	elseif dis<=150 and my_act==200 and my_allframe>=10 and ey==0 and enemy_obj_range_in(150,60)==false and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and is_dir_front==true and 
	((not(enemy_act>=50 and enemy_act<=166)and math.random(5)==1) or (enemy_act>=50 and enemy_act<=166)) and 
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("ダッシュ2Ａ");
		key_event2(ACT_A,ACT_DOWN);
--刻み4Ａ
	elseif (dis<=50+30 or (dis<=80 and my_xspeed>0)) and my_act==303 and ey==0 and my_hitstop<=3 and my_hitstop>=2 and enemy_obj_range_in(150,60)==false and 
	((enemy_act>=143 and enemy_act<=166) or (enemy_act>=50 and enemy_act<=89 and math.random(3)<=2)) and 
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("刻み2Ａ");
		key_event2(ACT_A,back);
		wait(3);
		
--遠距離：地上：２C　上空に人形設置。もっとも隙が少ない
--２C　ｈｊｃ：J2C　地上最低空に人形設置。
--相手の行動を見計らいつつ、１〜６飛翔。
--人形設置しながら、隙を見て６B、J6Bで牽制。
--



--Ａ
	elseif (	(	
					(	dis>=150 and
						(ex)*my_dir-(enemy_xspeedEX)*13		<=	400+30 	and
						(ex)*my_dir-(enemy_xspeedEX)*13		>=	200-30 	and
						(ey+enemy_yspeed*13+(13*(12*e_gs))/2)	<=	150 		and
						(ey+enemy_yspeed*13+(13*(12*e_gs))/2)	>=	50-180
					) or
					(	dis<150 and
						(ex)*my_dir-(enemy_xspeedEX)*11		<=	120+30 	and
						--(ex)*my_dir-(enemy_xspeedEX)*11		>=	20-30 	and
						(ey+enemy_yspeed*11+(11*(10*e_gs))/2)	<=	80 		and
						(ey+enemy_yspeed*11+(11*(10*e_gs))/2)	>=	20-180
					)
				)
	) and y==0 and ey<100 and enemy_obj_range_in(150,60)==false and my_act<=10 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and 
	is_dir_front==true and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("Ａ");
		key_event(ACT_A);
--2Ａ
	elseif dis<=150 and y==0 and ey==0 and not(enemy_act>=6 and enemy_act<=8) and not(enemy_act>=208 and enemy_act<=212) and enemy_obj_range_in(150,60)==false and my_act<=10 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and 
	is_dir_front==true and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("2Ａ");
		key_event2(ACT_A,ACT_DOWN);
--ＤＡ
	elseif dis<=250 and y==0 and ey==0 and not(enemy_act>=6 and enemy_act<=8) and not(enemy_act>=208 and enemy_act<=212) and enemy_obj_range_in(150,60)==false and my_act<=10 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and 
	is_dir_front==true and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("ＤＡ");
		key_on(frontEX());
		key_event2(ACT_D,ACT_A);
--ＤB
	elseif dis<=500 and dis>=400 and y==0 and ey==0 and not(enemy_act>=6 and enemy_act<=8) and not(enemy_act>=208 and enemy_act<=212) and enemy_obj_range_in(150,60)==false and my_act<=10 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and 
	is_dir_front==true and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("ＤB");
		key_on(frontEX());
		key_event2(ACT_D,ACT_B);
--ＤC
	elseif dis<=500 and dis>=400 and y==0 and ey==0 and not(enemy_act>=6 and enemy_act<=8) and not(enemy_act>=208 and enemy_act<=212) and enemy_obj_range_in(150,60)==false and my_act<=10 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and 
	is_dir_front==true and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("ＤC");
		key_on(frontEX());
		key_event2(ACT_D,ACT_C);
--A：硬直差し込み
	elseif dis<=300 and y==0 and ey<100 and enemy_obj_range_in(150,60)==false and my_act<=10 and enemy_act>=300 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("硬直差し込み：A");
		key_event(ACT_A);
		
--6Ｂ
	elseif dis>=400 and (my_act<=10 or my_act>=200 and my_act<=300) and	ey>=y-20 and ey<=y+40 and	not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and enemy_obj_range_in(150,60)==false and is_dir_front==true and my_rei>=600 and 
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("条件範囲内：6B");
		key_event2(ACT_B,front);
		if y==0 and 43-my_allframe>=1 then
			while (y==0 and 43-my_allframe>=1 and (enemy_act<300 or (enemy_act>=300 and get_fflags(1,64)) or (enemy_act>=300 and dis>=300))) do
				yield();
			end
		elseif y>0 and 51-my_allframe>=1 then
			while (y>0 and 51-my_allframe>=1 and (enemy_act<300 or (enemy_act>=300 and get_fflags(1,64)) or (enemy_act>=300 and dis>=300))) do
				yield();
			end
		end
		
--2C
	elseif dis>=400 and y==0 and my_act<=10 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and enemy_obj_range_in(150,60)==false and is_dir_front==true and my_rei>=600 and 
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("条件範囲内：2C");
		key_event(ACT_C);
		if 19-my_allframe>=1 then
			wait(19-my_allframe);
		end
		if dis<=300 and enemy_act>=300 and enemy_act<400 then
			key_event2(ACT_D,back);
		else
			key_event(ACT_UP);
		end
		if 3-my_allframe>=1 then
			wait(3-my_allframe);
		end
		if dis>=400 and 
		not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true then
			print("条件範囲内：JC");
			if math.random(1+20)==1 then
				key_on(ACT_C);
				key_on(ACT_DOWN);
				wait(29+2);
				key_resetEX();
			else
				key_event(ACT_C);
			end
		else
			key_resetEX();
			wait(2);
		end
			
--なんとなく人形振起
	elseif dis2>=400 and y==0 and my_act<=10 and 
	not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and 
	enemy_obj_range_in(150,60)==false and 
	card_check(103) and my_rei>=600 and math.random(1+15)==1 then
		print("攻撃＞スキルカード：人形振起");
		card_use(103);
	elseif dis2>=400 and y==0 and my_act<=10 and 
	not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and 
	enemy_obj_range_in(150,60)==false and 
	get_skill_lv(0,3)>=0 and my_rei>=600 and math.random(1+15)==1 then
		print("攻撃＞コマンド：B人形振起");
		key_resetEX(); key_on(ACT_D); yield(); key_resetEX();
		lvr22(ACT_B);
		if my_hitstop>=6 then
			wait(my_hitstop-5)
		end
--]]
--中距離以上からの８ｈｊ
	elseif move_8hjattakeovermidrange_condi()==true then
		print("中距離以上で８ＨＪ");
		key_event2(ACT_D,ACT_UP);
--中距離からのダッシュ
	elseif move_6dattakeovermidrange_condi()==true then
		print("ダッシュ接近");
		key_event2(ACT_D,front);
--低空飛翔で接近
	elseif move_approachbylowflaying_condi()==true then
		move_approachbylowflaying_exe()
--８８３飛翔
	elseif move_approachby883d_condi()==true then
		move_approachby883d_exe()
--▼ 終端運動
--▼ 相手上空へ飛び上がった際の処理
	elseif move_attakeoverhead_condi()==true then
		move_attakeoverhead_exe()
--▼ 終端機動
	--▼ 対台風時
	elseif move_terminationtaihu_condi()==true then
		move_terminationtaihu_exe()
	--▼ 終端機動1
	--台風じゃない時だが…
	elseif move_termination1_condi()==true then
		move_termination1_exe()
	--▼ 終端機動2
	--ただ動く事で自律性を錯覚させる事が目的の機動。静止やラインの設定に大きな根拠はない。
	--霊力が一定の評価を下回った場合、実行しない。
	elseif move_termination2_condi()==true then
		move_termination2_exe()
	end
	
	yield()
end
end